"use strict";
exports.__esModule = true;
exports.EnvalidModule = exports.makeValidators = void 0;
var tslib_1 = require("tslib");
var common_1 = require("@nestjs/common");
var envalid_1 = require("envalid");
var envalid_constants_1 = require("./envalid.constants");
var middleware_1 = require("./middleware");
function makeValidators(specs) {
    return {
        _specs: specs,
        values: specs
    };
}
exports.makeValidators = makeValidators;
var EnvalidModule = /** @class */ (function () {
    function EnvalidModule() {
    }
    EnvalidModule_1 = EnvalidModule;
    EnvalidModule.forRoot = function (config) {
        if (config.useDotenv) {
            /* eslint-disable-next-line @typescript-eslint/no-var-requires */
            require('dotenv').config();
        }
        var isGlobal = config.isGlobal, _a = config.environment, environment = _a === void 0 ? process.env : _a, options = config.options, _b = config.applyMiddleware, applyMiddleware = _b === void 0 ? middleware_1.applyDefaultMiddleware : _b;
        var validators = config.validators;
        if ('_specs' in validators) {
            validators = validators._specs;
        }
        var providers = [
            {
                provide: envalid_constants_1.ENVALID,
                useValue: envalid_1.customCleanEnv(environment, validators, applyMiddleware, options)
            },
        ];
        return {
            global: isGlobal,
            module: EnvalidModule_1,
            exports: providers,
            providers: providers
        };
    };
    var EnvalidModule_1;
    EnvalidModule = EnvalidModule_1 = tslib_1.__decorate([
        common_1.Module({})
    ], EnvalidModule);
    return EnvalidModule;
}());
exports.EnvalidModule = EnvalidModule;
//# sourceMappingURL=envalid.module.js.map